<?php
/*
 +-------------------------------------------------------------------------+
 | Copyright (C) 2006 Reinhard Scheck aka gandalf                          |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
 */

chdir('../../');
include("./include/auth.php");
define("MAX_DISPLAY_PAGES", 21);

/* set default action */
if (!isset($_REQUEST["action"])) { $_REQUEST["action"] = ""; }

switch ($_REQUEST["action"]) {
	case 'save':
		form_save();

		break;
	case 'actions':
		form_actions();

		break;
	case 'item_movedown':
		item_movedown();

		header("Location: nectar.php?action=edit&id=" . $_GET["id"]);
		break;
	case 'item_moveup':
		item_moveup();

		header("Location: nectar.php?action=edit&id=" . $_GET["id"]);
		break;
	case 'item_remove':
		item_remove();

		header("Location: nectar.php?action=edit&id=" . $_GET["id"]);
		break;
	case 'item_edit':
		include_once($config['include_path'] . "/top_header.php");

		item_edit();

		include_once($config['include_path'] . "/bottom_footer.php");
		break;
	case 'remove':
		nectar_remove();

		header ("Location: nectar.php");
		break;
	case 'edit':
		include_once($config['include_path'] . "/top_header.php");

		nectar_edit();

		include_once($config['include_path'] . "/bottom_footer.php");
		break;
	default:
		include_once($config['include_path'] . "/top_header.php");

		nectar();

		include_once($config['include_path'] . "/bottom_footer.php");
		break;
}


/* --------------------------
 The Save Function
 -------------------------- */
function form_save() {
	global $config, $messages;
	# when using cacti_log: include_once($config['library_path'] . "/functions.php");

	if (isset($_POST["save_component_nectar"])) {

		/* ================= input validation ================= */
		input_validate_input_number(get_request_var_post("id"));
		/* ==================================================== */
		$now = time();

		$save["id"] = $_POST["id"];
		$save["name"] = sql_sanitize(form_input_validate($_POST["name"], "name", "", false, 3));
		$save["intrvl"] = form_input_validate($_POST["intrvl"], "intrvl", "^[0-9]+$", false, 3);
		$save["count"] = form_input_validate($_POST["count"], "count", "^[0-9]+$", false, 3);
		$save["offset"] = form_input_validate($_POST["offset"], "offset", "^[0-9]+$", false, 3);
		if (($timestamp = strtotime($_POST["mailtime"])) === false) {
			$timestamp = $now;
		}
		if (($timestamp + read_config_option("poller_interval")) < $now) {
			# force error message to mark the failing field, but provide "formatted" mailtime!
			$save["mailtime"] = form_input_validate($_POST["mailtime"], "mailtime", "^[a-z]+$", false, "mg_mailtime_invalid");
		} else {
			$save["mailtime"] = form_input_validate($timestamp, "mailtime", "^[0-9]+$", false, 3);
		}
		$save['from_email'] = sql_sanitize($_POST['from_email']);
		$save['email'] = sql_sanitize($_POST['email']);
		if ($_POST['attachment_type'] != NECTAR_TYPE_PNG && $_POST['attachment_type'] != NECTAR_TYPE_JPG && $_POST['attachment_type'] != NECTAR_TYPE_GIF && $_POST['attachment_type'] != NECTAR_TYPE_PDF)
		$_POST['attachment_type'] = NECTAR_TYPE_PNG;
		$save['attachment_type'] = form_input_validate($_POST["attachment_type"], "attachment_type", "^[0-9]+$", false, 3);
		$save['lastsent'] = 0;
		$save["enabled"] = (isset($_POST["enabled"]) ? "on" : "");
		if (!is_error_message()) {
			$id = sql_save($save, "plugin_nectar");

			if ($id) {
				raise_message(1);
			}else{
				raise_message(2);
			}
		}

		#		if ((is_error_message()) || (empty($_POST["id"]))) {
		header("Location: nectar.php?action=edit&id=" . (empty($id) ? $_POST["id"] : $id));
		#		}else{
		#			header("Location: nectar.php");
		#		}
	}elseif (isset($_POST["save_component_nectar_item"])) {

		/* ================= input validation ================= */
		input_validate_input_number(get_request_var_post("report_id"));
		input_validate_input_number(get_request_var_post("id"));
		/* ==================================================== */
		unset($save);
		$save["id"] 			= form_input_validate($_POST["id"], "", "^[0-9]+$", false, 3);
		$save["report_id"] 		= form_input_validate($_POST["report_id"], "report_id", "^[0-9]+$", false, 3);
		$save["sequence"] 		= form_input_validate($_POST["sequence"], "sequence", "^[0-9]+$", false, 3);
		$save["item_type"] 		= form_input_validate($_POST["item_type"], "item_type", "^[-0-9]+$", true, 3);
		$save["host_id"] 		= (isset($_POST["host_id"]) 		? form_input_validate($_POST["host_id"], "host_id", "^[-0-9]+$", true, 3) 				: 0);
		$save["local_graph_id"] = (isset($_POST["local_graph_id"]) 	? form_input_validate($_POST["local_graph_id"], "local_graph_id", "^[0-9]+$", true, 3) 	: 0);
		$save["timespan"] 		= (isset($_POST["timespan"]) 		? form_input_validate($_POST["timespan"], "timespan", "^[0-9]+$", true, 3) 					: 0);
		$save["item_text"] 		= (isset($_POST["item_text"]) 		? sql_sanitize(form_input_validate($_POST["item_text"], "item_text", "", true, 3)) 		: '');
		$save["align"] 			= (isset($_POST["align"]) 			? form_input_validate($_POST["align"], "align", "^[0-9]+$", true, 3) 					: NECTAR_ALIGN_LEFT);
		$save["font_size"] 		= (isset($_POST["font_size"]) 		? form_input_validate($_POST["font_size"], "font_size", "^[0-9]+$", true, 3) 			: NECTAR_FONT_SIZE);

		if (!is_error_message()) {
			$item_id = sql_save($save, "plugin_nectar_items");

			if ($item_id) {
				raise_message(1);
			}else{
				raise_message(2);
			}
		}

		if (is_error_message()) {
			header("Location: nectar.php?action=item_edit&id=" . $_POST["report_id"] . "&item_id=" . (empty($item_id) ? $_POST["id"] : $item_id));
		}else{
			header("Location: nectar.php?action=edit&id=" . $_POST["report_id"]);
		}
	} else {
		raise_message(2);
		header("Location: nectar.php");
	}
}


/* ------------------------
 The "actions" function
 ------------------------ */
function form_actions() {
	global $colors, $config;
	global $nectar_actions;
	include_once($config["base_path"]."/plugins/nectar/nectar_functions.php");

	/* if we are to save this form, instead of display it */
	if (isset($_POST["selected_items"])) {
		$selected_items = unserialize(stripslashes($_POST["selected_items"]));

		if ($_POST["drp_action"] == NECTAR_DELETE) { /* delete */
			db_execute("delete from plugin_nectar where " . array_to_sql_or($selected_items, "id"));
			db_execute("delete from plugin_nectar_items where " . str_replace("id", "report_id", array_to_sql_or($selected_items, "id")));

		}elseif ($_POST["drp_action"] == NECTAR_DUPLICATE) { /* duplicate */
			for ($i=0;($i<count($selected_items));$i++) {
				/* ================= input validation ================= */
				input_validate_input_number($selected_items[$i]);
				/* ==================================================== */
				nectar_log("form_actions duplicate: " . $selected_items[$i] . " name: " . $_POST["name_format"], false, "NECTAR TRACE", POLLER_VERBOSITY_MEDIUM);
				duplicate_nectar($selected_items[$i], $_POST["name_format"]);
			}
		}elseif ($_POST["drp_action"] == NECTAR_ENABLE) { /* enable */
			for ($i=0;($i<count($selected_items));$i++) {
				/* ================= input validation ================= */
				input_validate_input_number($selected_items[$i]);
				/* ==================================================== */
				nectar_log("form_actions enable: " . $selected_items[$i], false, "NECTAR TRACE", POLLER_VERBOSITY_MEDIUM);
				db_execute("UPDATE plugin_nectar SET enabled='on' where id=" . $selected_items[$i]);
			}
		}elseif ($_POST["drp_action"] == NECTAR_DISABLE) { /* disable */
			for ($i=0;($i<count($selected_items));$i++) {
				/* ================= input validation ================= */
				input_validate_input_number($selected_items[$i]);
				/* ==================================================== */
				nectar_log("form_actions disable: " . $selected_items[$i], false, "NECTAR TRACE", POLLER_VERBOSITY_MEDIUM);
				db_execute("UPDATE plugin_nectar SET enabled='' where id=" . $selected_items[$i]);
			}
		}elseif ($_POST["drp_action"] == NECTAR_SEND_NOW) { /* send now */
			include_once($config["base_path"] . '/plugins/nectar/nectar_functions.php');
			for ($i=0;($i<count($selected_items));$i++) {
				/* ================= input validation ================= */
				input_validate_input_number($selected_items[$i]);
				/* ==================================================== */
				nectar_log("form_actions send now, report_id: " . $selected_items[$i], false, "NECTAR TRACE", POLLER_VERBOSITY_MEDIUM);
				$nectar = db_fetch_row("select * from plugin_nectar where id =" . $selected_items[$i]);
				if (isset($nectar['email'])) {
					generate_nectar($nectar, true);
				}
			}
		}

		header("Location: nectar.php");
		exit;
	}

	/* setup some variables */
	$nectar_list = ""; $i = 0;
	/* loop through each of the graphs selected on the previous page and get more info about them */
	while (list($var,$val) = each($_POST)) {
		if (ereg("^chk_([0-9]+)$", $var, $matches)) {
			/* ================= input validation ================= */
			input_validate_input_number($matches[1]);
			/* ==================================================== */
			$nectar_list .= "<li>" . db_fetch_cell("select name from plugin_nectar where id=" . $matches[1]) . "<br>";
			$nectar_array[$i] = $matches[1];
			$i++;
		}
	}

	include_once("./include/top_header.php");
	#print "<pre>"; print_r($_POST); print_r($_GET); print_r($_REQUEST); print "</pre>";

	print "<form name='nectar' action='nectar.php' method='post'>";

	html_start_box("<strong>" . $nectar_actions{$_POST["drp_action"]} . "</strong>", "60%", $colors["header_panel"], "3", "center", "");

	if ($_POST["drp_action"] == NECTAR_DELETE) { /* delete */
		print "	<tr>
			<td class='textArea' bgcolor='#" . $colors["form_alternate1"]. "'>
				<p>Are you sure you want to delete the following Reports?</p>
				<p>$nectar_list</p>
			</td>
		</tr>\n
		";
	}elseif ($_POST["drp_action"] == NECTAR_DUPLICATE) { /* duplicate */
		print "	<tr>
			<td class='textArea' bgcolor='#" . $colors["form_alternate1"]. "'>
				<p>When you click save, the following Reports will be duplicated. You can
				optionally change the title format for the new Reports.</p>
				<p>$nectar_list</p>
				<p><strong>Name Format:</strong><br>"; form_text_box("name_format", "<name> (1)", "", "255", "30", "text"); print "</p>
			</td>
		</tr>\n
		";
	}elseif ($_POST["drp_action"] == NECTAR_ENABLE) { /* enable */
		print "	<tr>
			<td class='textArea' bgcolor='#" . $colors["form_alternate1"]. "'>
				<p>When you click save, the following Reports will be enabled.</p>
				<p>$nectar_list</p>
				<p><strong>Make sure, that those Reports have successfully been tested!</strong></p>
			</td>
		</tr>\n
		";
	}elseif ($_POST["drp_action"] == NECTAR_DISABLE) { /* disable */
		print "	<tr>
			<td class='textArea' bgcolor='#" . $colors["form_alternate1"]. "'>
				<p>When you click save, the following Reports will be disabled.</p>
				<p>$nectar_list</p>
			</td>
		</tr>\n
		";
	}elseif ($_POST["drp_action"] == NECTAR_SEND_NOW) { /* send now */
		print "	<tr>
			<td class='textArea' bgcolor='#" . $colors["form_alternate1"]. "'>
				<p>When you click save, the following Reports will be send now.</p>
				<p>$nectar_list</p>
			</td>
		</tr>\n
		";
	}

	if (!isset($nectar_array)) {
		print "<tr><td bgcolor='#" . $colors["form_alternate1"]. "'><span class='textError'>You must select at least one Report.</span></td></tr>\n";
		$save_html = "";
	}else{
		$save_html = "<input type='image' src='../../images/button_yes.gif' alt='Save' align='middle' border='0'>";
	}

	print "	<tr>
		<td align='right' bgcolor='#eaeaea'>
			<input type='hidden' name='action' value='actions'>
			<input type='hidden' name='selected_items' value='" . (isset($nectar_array) ? serialize($nectar_array) : '') . "'>
			<input type='hidden' name='drp_action' value='" . $_POST["drp_action"] . "'>
			<a href='nectar.php'><img src='../../images/button_no.gif' alt='Cancel' align='middle' border='0'></a>
			$save_html
		</td>
	</tr>";

			html_end_box();

			include_once("./include/bottom_footer.php");
}

/* --------------------------
 Nectar Item Functions
 -------------------------- */
function item_movedown() {
	/* ================= input validation ================= */
	input_validate_input_number(get_request_var("item_id"));
	input_validate_input_number(get_request_var("id"));
	/* ==================================================== */
	move_item_down("plugin_nectar_items", get_request_var("item_id"), "report_id=" . get_request_var("id"));
}

function item_moveup() {
	/* ================= input validation ================= */
	input_validate_input_number(get_request_var("item_id"));
	input_validate_input_number(get_request_var("id"));
	/* ==================================================== */
	move_item_up("plugin_nectar_items", get_request_var("item_id"), "report_id=" . get_request_var("id"));
}

function item_remove() {
	/* ================= input validation ================= */
	input_validate_input_number(get_request_var("item_id"));
	/* ==================================================== */
	db_execute("delete from plugin_nectar_items where id=" . get_request_var("item_id"));
}

function item_edit() {
	global $config, $colors;
	global $fields_nectar_item_edit;

	/* ================= input validation ================= */
	input_validate_input_number(get_request_var("id"));
	input_validate_input_number(get_request_var("item_id"));
	input_validate_input_number(get_request_var("host_id"));
	input_validate_input_number(get_request_var("rule_type"));
	/* ==================================================== */
	#print "<pre>Post: "; print_r($_POST); print "Get: "; print_r($_GET); print "Request: "; print_r($_REQUEST); print "Session: "; print_r($_SESSION); print "</pre>";

	# fetch the current nectar record
	$nectar = db_fetch_row("SELECT * " .
					"FROM plugin_nectar " .
					"WHERE id=" . get_request_var_request("id"));

	# if an existing item was requested, fetch data for it
	if (get_request_var_request("item_id", '') !== '') {
		$nectar_item = db_fetch_row("SELECT * " .
							"FROM plugin_nectar_items" .
							" WHERE id=" . get_request_var_request("item_id"));
		$header_label = "[edit Report Item: " . $nectar['name'] . "]";
	}else{
		$header_label = "[new Report Item: " . $nectar['name'] . "]";
		$nectar_item = array();
		$nectar_item["report_id"] = get_request_var_request("id");
		$nectar_item["sequence"] = get_sequence('', 'sequence', 'plugin_nectar_items', 'report_id=' . get_request_var_request("id"));
		$nectar_item["host_id"] = NECTAR_HOST_NONE;
	}

	# if a different host_id was selected, use it
	if (get_request_var_request("host_id", '') !== '') {
		$nectar_item["host_id"] = get_request_var_request("host_id");
	}
	#print "<pre>Items: "; print_r($nectar_item); print "</pre>";


	# ready for displaying the fields
	html_start_box("<strong>Report Item</strong> $header_label", "100%", $colors["header"], "3", "center", "");

	draw_edit_form(array(
		"config" => array('form_name' => 'nectar_item_edit'),
		"fields" => inject_form_variables($fields_nectar_item_edit, (isset($nectar_item) ? $nectar_item : array()), (isset($nectar) ? $nectar : array()))
	));

	html_end_box();

	form_save_button(htmlspecialchars("nectar.php?action=edit&id=" . get_request_var_request("id")));
	//Now we need some javascript to make it dynamic
	?>
<script type="text/javascript">

toggle_item_type();

function toggle_item_type() {
	// right bracket ")" does not come with a field
	if (document.getElementById('item_type').value == '<?php print NECTAR_ITEM_GRAPH;?>') {
		//alert("Sequence is '" + document.getElementById('sequence').value + "'");
		document.getElementById('host_id').disabled='';
		document.getElementById('local_graph_id').disabled='';
		document.getElementById('timespan').disabled='';
		document.getElementById('item_text').value = '';
		document.getElementById('item_text').disabled='disabled';
		document.getElementById('font_size').value = '<?php print NECTAR_FONT_SIZE;?>';
		document.getElementById('font_size').disabled='disabled';
	} else {
		//document.getElementById('host_id').value='';
		document.getElementById('host_id').disabled='disabled';
		//document.getElementById('local_graph_id').value='';
		document.getElementById('local_graph_id').disabled='disabled';
		//document.getElementById('timespan').value='';
		document.getElementById('timespan').disabled='disabled';
		document.getElementById('item_text').disabled='';
		document.getElementById('font_size').disabled='';
	}
}

function applyHostIdChange(objForm) {
	strURL = '?action=item_edit&id=' + objForm.report_id.value;
	strURL = strURL + '&host_id=' + objForm.host_id.value;
	//if (typeof(name) != 'undefined') {
	//	strURL = strURL + '&name=' + objForm.name.value;
	//}
	//strURL = strURL + '&graph_rule_rows=' + objForm.graph_rule_rows.value;
	//alert('Url: ' + strURL);
	document.location = strURL;
}
</script>
	<?php
}


/* ---------------------
 Nectar Functions
 --------------------- */
function nectar_remove() {
	/* ================= input validation ================= */
	input_validate_input_number(get_request_var("id"));
	/* ==================================================== */

	if ((read_config_option("deletion_verification") == "on") && (!isset($_GET["confirm"]))) {
		include("./include/top_header.php");
		form_confirm("Are You Sure?", "Are you sure you want to delete the Report <strong>'" . db_fetch_cell("select name from nectar where id=" . $_GET["id"]) . "'</strong>?", "nectar.php", "nectar.php?action=remove&id=" . $_GET["id"]);
		include("./include/bottom_footer.php");
		exit;
	}

	if ((read_config_option("deletion_verification") == "") || (isset($_GET["confirm"]))) {
		db_execute("DELETE FROM plugin_nectar_items " .
					"WHERE report_id=" . $_GET["id"]);
		db_execute("delete from plugin_nectar where id=" . $_GET["id"]);
	}
}


function nectar_edit() {
	global $colors, $config;
	global $fields_nectar_edit;
	include_once($config["base_path"]."/plugins/nectar/nectar_functions.php");
	#print "<pre>Post: "; print_r($_POST); print "Get: "; print_r($_GET); print "Request: "; print_r($_REQUEST); print "Session: "; print_r($_SESSION); print "</pre>";

	/* ================= input validation ================= */
	input_validate_input_number(get_request_var_request("id"));
	input_validate_input_number(get_request_var_request("page"));
	/* ==================================================== */

	/* clean up rule name */
	if (isset($_REQUEST["name"])) {
		$_REQUEST["name"] = sanitize_search_string(get_request_var("name"));
	}

	/* remember these search fields in session vars so we don't have to keep passing them around */
	load_current_session_value("page", "sess_nectar_current_page", "1");
	load_current_session_value("nectar_rows", "sess_nectar_rows", read_config_option("num_rows_data_query"));

	/* handle show_hosts mode */
	if (isset($_GET["show_events"])) {
		if ($_GET["show_events"] == "0") {
			kill_session_var("nectar_show_events");
		}elseif ($_GET["show_events"] == "1") {
			$_SESSION["nectar_show_events"] = true;
		}
	}

	/* handle preview mode */
	if (isset($_GET["preview"])) {
		if ($_GET["preview"] == "0") {
			kill_session_var("nectar_preview");
		}elseif ($_GET["preview"] == "1") {
			$_SESSION["nectar_preview"] = true;
		}
	}

	/*
	 * display the nectar -------------------------------------------------------------------------------------
	 */
	$nectar = array();
	if (!empty($_GET["id"])) {
		$nectar = db_fetch_row("SELECT * FROM plugin_nectar where id=" . $_GET["id"]);
		# reformat mailtime to human readable format
		$nectar["mailtime"] = date(nectar_date_time_format(), $nectar["mailtime"]);
		# setup header
		$header_label = "[edit: " . $nectar["name"] . "]";
	}else{
		$header_label = "[new]";
		# initialize mailtime with current timestamp
		$nectar["mailtime"] = date(nectar_date_time_format(), floor(time() / read_config_option("poller_interval")) * read_config_option("poller_interval"));
	}


	/*
	 * show hosts? ------------------------------------------------------------------------------------------
	 */
	if (!empty($_GET["id"])) {
		?>
<table width="100%" align="center">
	<tr>
		<td class="textInfo" align="right" valign="top"><span
			style="color: #c16921;">*<a
			href='<?php print htmlspecialchars("nectar.php?action=edit&id=" . (isset($_GET["id"]) ? $_GET["id"] : 0) . "&show_events=") . (isset($_SESSION["nectar_show_events"]) ? "0" : "1");?>'><strong><?php print (isset($_SESSION["nectar_show_events"]) ? "Don't Show" : "Show");?></strong>
		Next Events.</a></span><br>
		</td>
	</tr>
</table>
		<?php
	}

	/*
	 * preview? ------------------------------------------------------------------------------------------
	 */
	if (!empty($_GET["id"])) {
		?>
<table width="100%" align="center">
	<tr>
		<td class="textInfo" align="right" valign="top"><span
			style="color: #c16921;">*<a
			href='<?php print htmlspecialchars("nectar.php?action=edit&id=" . (isset($_GET["id"]) ? $_GET["id"] : 0) . "&preview=") . (isset($_SESSION["nectar_preview"]) ? "0" : "1");?>'><strong><?php print (isset($_SESSION["nectar_preview"]) ? "Don't Show" : "Show");?></strong>
		Preview.</a></span><br>
		</td>
	</tr>
</table>
		<?php
	}


	print "<form method='post' action='nectar.php' name='form_nectar_edit'>";
	html_start_box("<strong>Report Selection</strong> $header_label", "100%", $colors["header"], "3", "center", "");
	#print "<pre>"; print_r($_POST); print_r($_GET); print_r($_REQUEST); print "</pre>";

	draw_edit_form(array(
		"config" => array("no_form_tag" => true),
		"fields" => inject_form_variables($fields_nectar_edit, $nectar)
	));

	html_end_box();

	/*
	 * display the items -------------------------------------------------------------------------------
	 */
	if (!empty($nectar["id"])) {
		# display nectar_data
		display_nectar_items($nectar["id"]);
	}
	/*
	 * display the preview -------------------------------------------------------------------------------
	 */
	if (!empty($nectar["id"]) && isset($_SESSION["nectar_preview"]) && ($_SESSION["nectar_preview"] == "1")) {
		# preview
		nectar_preview($nectar["id"]);
	}

	form_save_button("nectar.php");


	if (!empty($nectar["id"])) {
		/* display list of matching events */
		if (isset($_SESSION["nectar_show_events"])) {
			if (($timestamp = strtotime($nectar["mailtime"])) === false) {
				$timestamp = $now;
			}
			$timestamp = floor($timestamp / read_config_option("poller_interval")) * read_config_option("poller_interval");
			$next = nectar_interval_start($nectar["intrvl"], $nectar["count"], $nectar["offset"], $timestamp);
			$date_format = nectar_date_time_format() . " - l";

			html_start_box("<strong>Upcoming Events</strong>", "100%", $colors["header"], "3", "center", "");
			for ($i=0; $i<14; $i++) {
				form_alternate_row_color($colors["alternate"], $colors["light"], $i, 'line' . $i);
				form_selectable_cell(date($date_format, $next), $i);
				form_end_row();
				$next = nectar_interval_start($nectar["intrvl"], $nectar["count"], $nectar["offset"], $next);
			}
			html_end_box(false);
		}
	}
}


function nectar() {
	global $colors, $config, $item_rows, $nectar_interval;
	global $nectar_actions, $attach_types;
	#print "<pre>Post: "; print_r($_POST); print "Get: "; print_r($_GET); print "Request: ";  print_r($_REQUEST);  print "Session: ";  print_r($_SESSION); print "</pre>";
	include_once($config["base_path"]."/plugins/nectar/nectar_functions.php");

	/* ================= input validation ================= */
	input_validate_input_number(get_request_var_request("page"));
	input_validate_input_number(get_request_var_request("nectar_status"));
	input_validate_input_number(get_request_var_request("nectar_rows"));
	/* ==================================================== */

	/* clean up search string */
	if (isset($_REQUEST["filter"])) {
		$_REQUEST["filter"] = sanitize_search_string(get_request_var("filter"));
	}

	/* clean up sort_column string */
	if (isset($_REQUEST["sort_column"])) {
		$_REQUEST["sort_column"] = sanitize_search_string(get_request_var("sort_column"));
	}

	/* clean up sort_direction string */
	if (isset($_REQUEST["sort_direction"])) {
		$_REQUEST["sort_direction"] = sanitize_search_string(get_request_var("sort_direction"));
	}

	/* if the user pushed the 'clear' button */
	if (isset($_REQUEST["clear_x"])) {
		kill_session_var("sess_nectar_current_page");
		kill_session_var("sess_nectar_filter");
		kill_session_var("sess_nectar_sort_column");
		kill_session_var("sess_nectar_sort_direction");
		kill_session_var("sess_nectar_status");
		kill_session_var("sess_nectar_rows");

		unset($_REQUEST["page"]);
		unset($_REQUEST["filter"]);
		unset($_REQUEST["sort_column"]);
		unset($_REQUEST["sort_direction"]);
		unset($_REQUEST["nectar_status"]);
		unset($_REQUEST["nectar_rows"]);

	}

	if ((!empty($_SESSION["sess_nectar_status"])) && (!empty($_REQUEST["nectar_status"]))) {
		if ($_SESSION["sess_nectar_status"] != $_REQUEST["nectar_status"]) {
			$_REQUEST["page"] = 1;
		}
	}

	/* remember these search fields in session vars so we don't have to keep passing them around */
	load_current_session_value("page", "sess_nectar_current_page", "1");
	load_current_session_value("filter", "sess_nectar_filter", "");
	load_current_session_value("sort_column", "sess_nectar_sort_column", "name");
	load_current_session_value("sort_direction", "sess_nectar_sort_direction", "ASC");
	load_current_session_value("nectar_status", "sess_nectar_status", "-1");
	load_current_session_value("nectar_rows", "sess_nectar_rows", read_config_option("num_rows_device"));

	/* if the number of rows is -1, set it to the default */
	if ($_REQUEST["nectar_rows"] == -1) {
		$_REQUEST["nectar_rows"] = read_config_option("num_rows_device");
	}

	print ('<form name="form_nectar" action="nectar.php" method="GET">');

	html_start_box("<strong>Reports</strong>", "100%", $colors["header"], "3", "center", htmlspecialchars("nectar.php?action=edit"));

	$filter_html = '<tr bgcolor=' . $colors["panel"] . '>
					<td>
					<table width="100%" cellpadding="0" cellspacing="0">
						<tr>
							<td nowrap style="white-space: nowrap;" width="50">
								Search:&nbsp;
							</td>
							<td width="1"><input type="text" name="filter" size="40" value="' . get_request_var_request("filter") . '">
							</td>
							<td nowrap style="white-space: nowrap;" width="50">
								&nbsp;Status:&nbsp;
							</td>
							<td width="1">
								<select name="nectar_status" onChange="applyViewNectarFilterChange(document.form_nectar)">
									<option value="-1"';
	if (get_request_var_request("nectar_status") == "-1") {
		$filter_html .= 'selected';
	}
	$filter_html .= '>Any</option>					<option value="-2"';
	if (get_request_var_request("nectar_status") == "-2") {
		$filter_html .= 'selected';
	}
	$filter_html .= '>Enabled</option>				<option value="-3"';
	if (get_request_var_request("nectar_status") == "-3") {
		$filter_html .= 'selected';
	}
	$filter_html .= '>Disabled</option>';
	$filter_html .= '					</select>
							</td>
							<td nowrap style="white-space: nowrap;" width="50">
								&nbsp;Rows per Page:&nbsp;
							</td>
							<td width="1">
								<select name="nectar_rows" onChange="applyViewNectarFilterChange(document.form_nectar)">
								<option value="-1"';
	if (get_request_var_request("nectar_rows") == "-1") {
		$filter_html .= 'selected';
	}
	$filter_html .= '>Default</option>';
	if (sizeof($item_rows) > 0) {
		foreach ($item_rows as $key => $value) {
			$filter_html .= "<option value='" . $key . "'";
			if (get_request_var_request("nectar_rows") == $key) {
				$filter_html .= " selected";
			}
			$filter_html .= ">" . $value . "</option>\n";
		}
	}
	$filter_html .= '					</select>
							</td>
							<td nowrap style="white-space: nowrap;">&nbsp;<input type="image"
								src="../../images/button_go.gif" alt="Go"
								align="middle"> <input type="image"
								src="../../images/button_clear.gif" name="clear" alt="Clear"
								align="middle"></td>
						</tr>
					</table>
					</td>
					<td><input type="hidden" name="page" value="1"></td>
				</tr>';

	print $filter_html;

	html_end_box();

	print "</form>\n";

	/* form the 'where' clause for our main sql query */
	if (strlen(get_request_var_request("filter"))) {
		$sql_where = "WHERE (plugin_nectar.name LIKE '%%" . get_request_var_request("filter") . "%%')";
	}else{
		$sql_where = "";
	}

	if (get_request_var_request("nectar_status") == "-1") {
		/* Show all items */
	}elseif (get_request_var_request("nectar_status") == "-2") {
		$sql_where .= (strlen($sql_where) ? " and plugin_nectar.enabled='on'" : "where .plugin_nectar.enabled='on'");
	}elseif (get_request_var_request("nectar_status") == "-3") {
		$sql_where .= (strlen($sql_where) ? " and plugin_nectar.enabled=''" : "where plugin_nectar.enabled=''");
	}

	html_start_box("", "100%", $colors["header"], "3", "center", "");

	$total_rows = db_fetch_cell("SELECT " .
		"COUNT(plugin_nectar.id) " .
		"FROM plugin_nectar " .
	$sql_where);

	$nectar_list = db_fetch_assoc("SELECT " .
		"plugin_nectar.id, ".
		"plugin_nectar.name, " .
		"plugin_nectar.intrvl, " .
		"plugin_nectar.count, " .
		"plugin_nectar.offset, " .
		"plugin_nectar.mailtime, " .
		"plugin_nectar.from_email, " .
		"plugin_nectar.email, " .
		"plugin_nectar.attachment_type, " .
		"plugin_nectar.lastsent, " .
		"plugin_nectar.enabled " .
		"FROM plugin_nectar " .
	$sql_where .
		" ORDER BY " . get_request_var_request("sort_column") . " " . get_request_var_request("sort_direction") .
		" LIMIT " . (get_request_var_request("nectar_rows")*(get_request_var_request("page")-1)) . "," . get_request_var_request("nectar_rows"));

	/* generate page list */
	$url_page_select = get_page_list(get_request_var_request("page"), MAX_DISPLAY_PAGES, get_request_var_request("nectar_rows"), $total_rows, "nectar.php?filter=" . get_request_var_request("filter"));

	$nav = "<tr bgcolor='#" . $colors["header"] . "'>
		<td colspan='12'>
			<table width='100%' cellspacing='0' cellpadding='0' border='0'>
				<tr>
					<td align='left' class='textHeaderDark'>
						<strong>&lt;&lt; "; if (get_request_var_request("page") > 1) { $nav .= "<a class='linkOverDark' href='" . htmlspecialchars("nectar.php?filter=" . get_request_var_request("filter") . "&nectar_status=" . get_request_var_request("nectar_status") . "&page=" . (get_request_var_request("page")-1)) . "'>"; } $nav .= "Previous"; if (get_request_var_request("page") > 1) { $nav .= "</a>"; } $nav .= "</strong>
					</td>\n
					<td align='center' class='textHeaderDark'>
						Showing Rows " . ((get_request_var_request("nectar_rows")*(get_request_var_request("page")-1))+1) . " to " . ((($total_rows < read_config_option("num_rows_device")) || ($total_rows < (get_request_var_request("nectar_rows")*get_request_var_request("page")))) ? $total_rows : (get_request_var_request("nectar_rows")*get_request_var_request("page"))) . " of $total_rows [$url_page_select]
					</td>\n
					<td align='right' class='textHeaderDark'>
						<strong>"; if ((get_request_var_request("page") * get_request_var_request("nectar_rows")) < $total_rows) { $nav .= "<a class='linkOverDark' href='" . htmlspecialchars("nectar.php?filter=" . get_request_var_request("filter") . "&nectar_status=" . get_request_var_request("nectar_status") . "&page=" . (get_request_var_request("page")+1)) . "'>"; } $nav .= "Next"; if ((get_request_var_request("page") * get_request_var_request("nectar_rows")) < $total_rows) { $nav .= "</a>"; } $nav .= " &gt;&gt;</strong>
					</td>\n
				</tr>
			</table>
		</td>
	</tr>\n";

	print $nav;

	$display_text = array(
		"name" 				=> array("Report Title", "ASC"),
		"id" 				=> array("Id", "ASC"),
		"intrvl" 			=> array("Interval", "ASC"),
		"count" 			=> array("Count", "ASC"),
		"offset" 			=> array("Offset", "ASC"),
		"mailtime" 			=> array("Next Run", "ASC"),
		"lastsent"			=> array("Last Run", "ASC"),
		"from_email"		=> array("From", "ASC"),
		"email"				=> array("To", "ASC"),
		"attachment_type"	=> array("Type", "ASC"),
		"enabled" 			=> array("Enabled", "ASC"),
	);

	html_header_sort_checkbox($display_text, get_request_var_request("sort_column"), get_request_var_request("sort_direction"));

	$i = 0;
	if (sizeof($nectar_list) > 0) {
		$date_format = nectar_date_time_format();

		foreach ($nectar_list as $nectar) {
			form_alternate_row_color($colors["alternate"], $colors["light"], $i, 'line' . $nectar["id"]); $i++;

			form_selectable_cell("<a class='linkEditMain' href='" . htmlspecialchars("nectar.php?action=edit&id=" . $nectar["id"] . "&page=1 ' title='" . $nectar["name"]) . "'>" . ((get_request_var_request("filter") != "") ? eregi_replace("(" . preg_quote(get_request_var_request("filter")) . ")", "<span style='background-color: #F8D93D;'>\\1</span>", title_trim($nectar["name"], read_config_option("max_title_graph"))) : title_trim($nectar["name"], read_config_option("max_title_graph"))) . "</a>", $nectar["id"]);
			form_selectable_cell($nectar["id"], $nectar["id"]);
			form_selectable_cell((isset($nectar_interval{$nectar["intrvl"]})) ? $nectar_interval{$nectar["intrvl"]} : "Invalid Interval", $nectar["id"]);
			form_selectable_cell($nectar["count"], $nectar["id"]);
			form_selectable_cell($nectar["offset"], $nectar["id"]);
			form_selectable_cell(date($date_format, $nectar["mailtime"]), $nectar["id"]);
			form_selectable_cell(($nectar["lastsent"] == 0) ? 'never' : date($date_format, $nectar["lastsent"]), $nectar["lastsent"]);
			form_selectable_cell(((get_request_var_request("filter") != "") ? eregi_replace("(" . preg_quote(get_request_var_request("filter")) . ")", "<span style='background-color: #F8D93D;'>\\1</span>", $nectar["from_email"]) : $nectar["from_email"]), $nectar["id"]);
			form_selectable_cell(((get_request_var_request("filter") != "") ? eregi_replace("(" . preg_quote(get_request_var_request("filter")) . ")", "<span style='background-color: #F8D93D;'>\\1</span>", $nectar["email"]) : $nectar["email"]), $nectar["id"]);
			form_selectable_cell((isset($attach_types{$nectar["attachment_type"]})) ? $attach_types{$nectar["attachment_type"]} : "Invalid Attachment Type", $nectar["id"]);
			form_selectable_cell($nectar["enabled"] ? "Enabled" : "Disabled", $nectar["id"]);
			form_checkbox_cell($nectar["name"], $nectar["id"]);

			form_end_row();
		}
		print $nav;
	}else{
		print "<tr><td><em>No Reports</em></td></tr>\n";
	}
	html_end_box(false);

	/* draw the dropdown containing a list of available actions for this form */
	draw_actions_dropdown($nectar_actions);

	print "</form>\n";
	?>
<script type="text/javascript">
	<!--

	function applyViewNectarFilterChange(objForm) {
		strURL = 'nectar.php?nectar_status=' + objForm.nectar_status.value;
		strURL = strURL + '&nectar_rows=' + objForm.nectar_rows.value;
		strURL = strURL + '&filter=' + objForm.filter.value;
		document.location = strURL;
	}

	-->
	</script>
	<?php
}

?>
